
include \masm32\include\masm32rt.inc

; ------------------------------------------------------------------------------

; Prototype 
; ------------------------------------------------------------------------------
DialogProc   PROTO : HWND, : UINT, : WPARAM, : LPARAM
WindowProc    PROTO : HWND, : UINT, : WPARAM, : LPARAM
CenterWindow PROTO : HWND, : DWORD,:DWORD
.const

; Resource ids
; ------------------------------------------------------------------------------
IDD_DLG1  		      equ 101
IDI_ICON              equ 200
IDC_EXIT              equ 102
IDC_WINDOWBUTTON      equ 103
IDC_WINDOW            equ 104

; Required data

.data
szTitle     db "Centering a window on another window", 0
szTitle2    db "Another window",0

.data?

hInstance HINSTANCE ?
hIcon     HICON     ?
hDlg      HWND ?
rc        RECT <>

.code

start:

INVOKE InitCommonControls

INVOKE GetModuleHandle, NULL
mov hInstance, eax

INVOKE LoadIcon, eax, IDI_ICON 
mov hIcon, eax
; ---------------------------------------------
;   Call the dialog box stored in resource file
; --------------------------------------------
INVOKE DialogBoxParam, hInstance, IDD_DLG1 , NULL, ADDR DialogProc, 0
INVOKE ExitProcess, 0

; Dialog procedure
; ------------------------------------------------------------------------------
DialogProc proc hWnd: HWND, uMsg: UINT, wParam: WPARAM, lParam: LPARAM

 .IF uMsg == WM_INITDIALOG
 
  mov    eax,hWnd
  mov    hDlg,eax
  INVOKE SetWindowText, hWnd, addr szTitle 
  INVOKE SendMessage, hWnd, WM_SETICON,ICON_SMALL, hIcon
  
    .ELSEIF uMsg == WM_COMMAND
     
       
      .ELSEIF uMsg == WM_CLOSE
    INVOKE EndDialog, hWnd, 0
 
   .ENDIF 
  
    .IF wParam == IDC_EXIT 
      INVOKE SendMessage, hWnd, WM_CLOSE, 0, 0

    .ENDIF
    
    .IF wParam == IDC_WINDOWBUTTON 

invoke DialogBoxParam,hInstance,IDC_WINDOW,hWnd,addr WindowProc,0
        

    .ENDIF

    xor eax,eax
  ret
DialogProc endp

; Window procedure                                   
;-------------------------------------------------------------------------------------------------
WindowProc proc  hWnd: HWND, uMsg: UINT, wParam: WPARAM, lParam: LPARAM



    mov		eax,uMsg
    .IF eax == WM_INITDIALOG
    INVOKE SetWindowText, hWnd, addr szTitle2

;------------------

        INVOKE  GetWindowRect,hWnd,offset rc
        mov     edx,rc.bottom
        mov     ecx,rc.right
        sub     edx,rc.top
        sub     ecx,rc.left
        INVOKE  CenterWindow,hDlg,ecx,edx
        INVOKE  SetWindowPos,hWnd,NULL,ecx,edx,0,0,SWP_NOSIZE    

;------------------

    .ELSEIF eax == WM_COMMAND
    mov		eax,wParam
	and		eax,0FFFFh

 .ELSEIF eax == WM_CLOSE 
    	INVOKE EndDialog, hWnd, 0
   .ENDIF 


    xor eax,eax
  ret                
WindowProc endp

CenterWindow PROC winHandle:HWND,winWidth:DWORD,winHeight:DWORD

        LOCAL   gpRect:RECT

        INVOKE  GetWindowRect,winHandle,ADDR gpRect

; Calculate X-position of window:

        MOV     ECX,gpRect.right
        SUB     ECX,gpRect.left
        SUB     ECX,winWidth
        SAR     ECX,1
        ADD     ECX,gpRect.left

; Calculate Y-position of window:

        MOV     EDX,gpRect.bottom
        SUB     EDX,gpRect.top
        SUB     EDX,winHeight
        SAR     EDX,1
        ADD     EDX,gpRect.top
        RET

CenterWindow ENDP

end start